From 8317c332a7ba7c70bdabbe66740975529ce3a237 Mon Sep 17 00:00:00 2001
From: Steve MacLean <sdmaclea.qdt@qualcommdatacenter.com>
Date: Thu, 24 May 2018 20:08:44 -0400
Subject: [PATCH] [Arm64] JIT generate LSE Atomics

When ARMv8.1 LSE Atomics are available, use them to implement
Interlocked operations.
---
 src/jit/codegenarm64.cpp | 77 +++++++++++++++++++++++++++++++++++++++---------
 src/jit/lowerarmarch.cpp |  4 ++-
 src/jit/lsraarm64.cpp    | 18 +++++++++--
 3 files changed, 82 insertions(+), 17 deletions(-)

diff --git a/src/jit/codegenarm64.cpp b/src/jit/codegenarm64.cpp
index eaaf5ba..6734c3e 100644
--- a/src/jit/codegenarm64.cpp
+++ b/src/jit/codegenarm64.cpp
@@ -2660,6 +2660,39 @@ void CodeGen::genLockedInstructions(GenTreeOp* treeNode)
     regNumber dataReg   = data->gtRegNum;
     regNumber addrReg   = addr->gtRegNum;
 
+    genConsumeAddress(addr);
+    genConsumeRegs(data);
+
+    emitAttr dataSize = emitActualTypeSize(data);
+
+    if (compiler->compSupports(InstructionSet_Atomics))
+    {
+        assert(!data->isContainedIntOrIImmed());
+
+        switch (treeNode->gtOper)
+        {
+            case GT_XCHG:
+                getEmitter()->emitIns_R_R_R(INS_swpal, dataSize, dataReg, targetReg, addrReg);
+                break;
+            case GT_XADD:
+            case GT_LOCKADD:
+                if ((targetReg == REG_NA) || (targetReg == REG_ZR))
+                {
+                    getEmitter()->emitIns_R_R(INS_staddl, dataSize, dataReg, addrReg);
+                }
+                else
+                {
+                    getEmitter()->emitIns_R_R_R(INS_ldaddal, dataSize, dataReg, targetReg, addrReg);
+                }
+                break;
+            default:
+                assert(!"Unexpected treeNode->gtOper");
+        }
+
+        instGen_MemoryBarrier(INS_BARRIER_ISH);
+    }
+    else
+    {
         regNumber exResultReg  = treeNode->ExtractTempReg(RBM_ALLINT);
         regNumber storeDataReg = (treeNode->OperGet() == GT_XCHG) ? dataReg : treeNode->ExtractTempReg(RBM_ALLINT);
         regNumber loadReg      = (targetReg != REG_NA) ? targetReg : storeDataReg;
@@ -2685,19 +2718,14 @@ void CodeGen::genLockedInstructions(GenTreeOp* treeNode)
         noway_assert(exResultReg != storeDataReg);
         noway_assert(exResultReg != addrReg);
 
-    genConsumeAddress(addr);
-    genConsumeRegs(data);
-
-    // NOTE: `genConsumeAddress` marks the consumed register as not a GC pointer, as it assumes that the input registers
+        // NOTE: `genConsumeAddress` marks the consumed register as not a GC pointer, as it assumes that the input
+        // registers
         // die at the first instruction generated by the node. This is not the case for these atomics as the  input
         // registers are multiply-used. As such, we need to mark the addr register as containing a GC pointer until
         // we are finished generating the code for this node.
 
         gcInfo.gcMarkRegPtrVal(addrReg, addr->TypeGet());
 
-    // TODO-ARM64-CQ Use ARMv8.1 atomics if available
-    // https://github.com/dotnet/coreclr/issues/11881
-
         // Emit code like this:
         //   retry:
         //     ldxr loadReg, [addrReg]
@@ -2710,8 +2738,6 @@ void CodeGen::genLockedInstructions(GenTreeOp* treeNode)
         BasicBlock* labelRetry = genCreateTempLabel();
         genDefineTempLabel(labelRetry);
 
-    emitAttr dataSize = emitActualTypeSize(data);
-
         // The following instruction includes a acquire half barrier
         getEmitter()->emitIns_R_R(INS_ldaxr, dataSize, loadReg, addrReg);
 
@@ -2747,6 +2773,7 @@ void CodeGen::genLockedInstructions(GenTreeOp* treeNode)
         instGen_MemoryBarrier(INS_BARRIER_ISH);
 
         gcInfo.gcMarkRegSetNpt(addr->gtGetRegMask());
+    }
 
     if (treeNode->gtRegNum != REG_NA)
     {
@@ -2772,6 +2799,30 @@ void CodeGen::genCodeForCmpXchg(GenTreeCmpXchg* treeNode)
     regNumber dataReg      = data->gtRegNum;
     regNumber addrReg      = addr->gtRegNum;
     regNumber comparandReg = comparand->gtRegNum;
+
+    genConsumeAddress(addr);
+    genConsumeRegs(data);
+    genConsumeRegs(comparand);
+
+    if (compiler->compSupports(InstructionSet_Atomics))
+    {
+        emitAttr dataSize = emitActualTypeSize(data);
+
+        // casal use the comparand as the target reg
+        if (targetReg != comparandReg)
+        {
+            getEmitter()->emitIns_R_R(INS_mov, dataSize, targetReg, comparandReg);
+
+            // Catch case we destroyed data or address before use
+            noway_assert(addrReg != targetReg);
+            noway_assert(dataReg != targetReg);
+        }
+        getEmitter()->emitIns_R_R_R(INS_casal, dataSize, targetReg, dataReg, addrReg);
+
+        instGen_MemoryBarrier(INS_BARRIER_ISH);
+    }
+    else
+    {
         regNumber exResultReg = treeNode->ExtractTempReg(RBM_ALLINT);
 
         // Check allocator assumptions
@@ -2794,11 +2845,8 @@ void CodeGen::genCodeForCmpXchg(GenTreeCmpXchg* treeNode)
         noway_assert(exResultReg != dataReg);
         noway_assert(exResultReg != addrReg);
 
-    genConsumeAddress(addr);
-    genConsumeRegs(data);
-    genConsumeRegs(comparand);
-
-    // NOTE: `genConsumeAddress` marks the consumed register as not a GC pointer, as it assumes that the input registers
+        // NOTE: `genConsumeAddress` marks the consumed register as not a GC pointer, as it assumes that the input
+        // registers
         // die at the first instruction generated by the node. This is not the case for these atomics as the  input
         // registers are multiply-used. As such, we need to mark the addr register as containing a GC pointer until
         // we are finished generating the code for this node.
@@ -2854,6 +2902,7 @@ void CodeGen::genCodeForCmpXchg(GenTreeCmpXchg* treeNode)
         instGen_MemoryBarrier(INS_BARRIER_ISH);
 
         gcInfo.gcMarkRegSetNpt(addr->gtGetRegMask());
+    }
 
     genProduceReg(treeNode);
 }
diff --git a/src/jit/lowerarmarch.cpp b/src/jit/lowerarmarch.cpp
index c8f082b..6303c79 100644
--- a/src/jit/lowerarmarch.cpp
+++ b/src/jit/lowerarmarch.cpp
@@ -90,7 +90,9 @@ bool Lowering::IsContainableImmed(GenTree* parentNode, GenTree* childNode)
             case GT_CMPXCHG:
             case GT_LOCKADD:
             case GT_XADD:
-                return emitter::emitIns_valid_imm_for_add(immVal, size);
+                return comp->compSupports(InstructionSet_Atomics)
+                           ? false
+                           : emitter::emitIns_valid_imm_for_add(immVal, size);
 #elif defined(_TARGET_ARM_)
                 return emitter::emitIns_valid_imm_for_add(immVal, flags);
 #endif
diff --git a/src/jit/lsraarm64.cpp b/src/jit/lsraarm64.cpp
index 2025b3f..3fde351 100644
--- a/src/jit/lsraarm64.cpp
+++ b/src/jit/lsraarm64.cpp
@@ -421,16 +421,27 @@ int LinearScan::BuildNode(GenTree* tree)
             srcCount                    = cmpXchgNode->gtOpComparand->isContained() ? 2 : 3;
             assert(dstCount == 1);
 
+            if (!compiler->compSupports(InstructionSet_Atomics))
+            {
+                // For ARMv8 exclusives requires a single internal register
                 buildInternalIntRegisterDefForNode(tree);
+            }
 
             // For ARMv8 exclusives the lifetime of the addr and data must be extended because
             // it may be used used multiple during retries
+
+            // For ARMv8.1 atomic cas the lifetime of the addr and data must be extended to prevent
+            // them being reused as the target register which must be destroyed early
+
             RefPosition* locationUse = BuildUse(tree->gtCmpXchg.gtOpLocation);
             setDelayFree(locationUse);
             RefPosition* valueUse = BuildUse(tree->gtCmpXchg.gtOpValue);
             setDelayFree(valueUse);
-            if (!cmpXchgNode->gtOpComparand->isContained())
+            if (!cmpXchgNode->gtOpComparand->isContained() && !compiler->compSupports(InstructionSet_Atomics))
             {
+                // For ARMv8 exclusives the lifetime of the comparand must be extended because
+                // it may be used used multiple during retries
+
                 RefPosition* comparandUse = BuildUse(tree->gtCmpXchg.gtOpComparand);
                 setDelayFree(comparandUse);
             }
@@ -449,7 +460,9 @@ int LinearScan::BuildNode(GenTree* tree)
             assert(dstCount == (tree->TypeGet() == TYP_VOID) ? 0 : 1);
             srcCount = tree->gtGetOp2()->isContained() ? 1 : 2;
 
-            // GT_XCHG requires a single internal regiester; the others require two.
+            if (!compiler->compSupports(InstructionSet_Atomics))
+            {
+                // GT_XCHG requires a single internal register; the others require two.
                 buildInternalIntRegisterDefForNode(tree);
                 if (tree->OperGet() != GT_XCHG)
                 {
@@ -477,6 +490,7 @@ int LinearScan::BuildNode(GenTree* tree)
                     setInternalRegsDelayFree = true;
                 }
                 buildInternalRegisterUses();
+            }
             if (dstCount == 1)
             {
                 BuildDef(tree);
-- 
2.7.4

